//
// this fragment shader is specifically made for drawing the medium maps
//
// tex1: terrain heightmap
// tex2: gold & wood heightmap
//
// tex3-7: textures (sea, grass, hills, gold, wood)
//
precision mediump float;

uniform sampler2D texUnit1;		// texture unit
uniform sampler2D texUnit2;		// texture unit
uniform sampler2D texUnit3;		// texture unit
uniform sampler2D texUnit4;		// texture unit
uniform sampler2D texUnit5;		// texture unit
uniform sampler2D texUnit6;		// texture unit
uniform sampler2D texUnit7;		// texture unit
varying vec2 texCoordVar;			// texture coordinates from vertex shader
varying vec4 colorVar;				// color from vertex shader

void main()
{
	// heightmaps
	lowp vec4 terrain = texture2D(texUnit1, texCoordVar);
	lowp vec4 goldWood = texture2D(texUnit2, texCoordVar);

	// textures
	lowp vec4 sea = texture2D(texUnit3, texCoordVar);
	lowp vec4 grass = texture2D(texUnit4, texCoordVar);
	lowp vec4 hill = texture2D(texUnit5, texCoordVar);
	lowp vec4 wood = texture2D(texUnit6, texCoordVar);
	lowp vec4 gold = texture2D(texUnit7, texCoordVar);

	lowp vec4 dirt = grass * vec4(1.2, 1.0, 1.0, 1.0);

	lowp vec4 color = sea * 0.7;
	color = mix(color, sea, smoothstep(0.00, 0.03, terrain.r));
	color = mix(color, grass, smoothstep(0.03, 0.10, terrain.r));
	color = mix(color, dirt, smoothstep(0.70, 0.80, terrain.r));
	color = mix(color, hill, smoothstep(0.80, 1.00, terrain.r));
	color = mix(color, gold, smoothstep(0.80, 0.83, goldWood.r) * 0.5);
	color = mix(color, gold, smoothstep(0.83, 0.90, goldWood.r));
	color = mix(color, wood, 1.0 - smoothstep(0.15, 0.20, goldWood.r));

    gl_FragColor = color * colorVar;
}
