attribute vec4 position;                // vertex position
attribute vec2 texCoord;                // vertex texture coordinate
attribute vec4 color;					// vertex color

uniform mat4 projection;                // projection matrix
uniform vec4 noiseX;						// tile X, Y
 
varying vec2 texCoordVar;               // texture coordinate to fragment shader
varying vec2 texCoordAuxVar;            // texture coordinate to fragment shader (noise texture)
varying vec4 colorVar;					// color to fragment shader
 
void main()
{
    gl_Position = projection * position;
    texCoordVar = texCoord;
	texCoordAuxVar = vec2(noiseX.x + texCoord.s * 0.125, noiseX.y + texCoord.t * 0.0555);
	colorVar = color;
}

